Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.codehaus.groovy.antlr.parser
[Java] Class GroovyRecognizer

    java.lang.Object
      antlr.Parser
          antlr.LLkParser
              org.codehaus.groovy.antlr.parser.GroovyRecognizer

All Implemented Interfaces:
  GroovyTokenTypes

    public class GroovyRecognizer
    extends antlr.LLkParser

JSR-241 Groovy Recognizer. Run 'java Main [-showtree] directory-full-of-groovy-files' [The -showtree option pops up a Swing frame that shows the AST constructed from the parser.] Contributing authors: John Mitchell johnm

non.net:
  Terence Parr parrt@magelang.com John Lilley jlilley@empathy.com Scott Stanchfield thetick@magelang.com Markus Mohnen mohnen@informatik.rwth-aachen.de Peter Williams pete.williams@sun.com Allan Jacobs Allan.Jacobs@eng.sun.com Steve Messick messick@redhills.com James Strachan jstrachan@protique.com John Pybus john@pybus.org John Rose rose00@mac.com Jeremy Rayner groovy@ross-rayner.com Alex Popescu the.mindstorm@gmail.com Martin Kempf mkempf@hsr.ch Reto Kleeb rkleeb@hsr.ch Version 1.00 December 9, 1997 -- initial release Version 1.01 December 10, 1997 fixed bug in octal def (0..7 not 0..8) Version 1.10 August 1998 (parrt) added tree construction fixed definition of WS,comments for mac,pc,unix newlines added unary plus Version 1.11 (Nov 20, 1998) Added "shutup" option to turn off last ambig warning. Fixed inner class def to allow named class defs as statements synchronized requires compound not simple statement add [] after builtInType DOT class in primaryExpression "const" is reserved but not valid..removed from modifiers Version 1.12 (Feb 2, 1999) Changed LITERAL_xxx to xxx in tree grammar. Updated java.g to use tokens {...} now for 2.6.0 (new feature). Version 1.13 (Apr 23, 1999) Didn't have (stat)? for else clause in tree parser. Didn't gen ASTs for interface extends. Updated tree parser too. Updated to 2.6.0. Version 1.14 (Jun 20, 1999) Allowed final/abstract on local classes. Removed local interfaces from methods Put instanceof precedence where it belongs...in relationalExpr It also had expr not type as arg; fixed it. Missing ! on SEMI in classBlock fixed: (expr) + "string" was parsed incorrectly (+ as unary plus). fixed: didn't like Object[].class in parser or tree parser Version 1.15 (Jun 26, 1999) Screwed up rule with instanceof in it. :( Fixed. Tree parser didn't like (expr).something; fixed. Allowed multiple inheritance in tree grammar. oops. Version 1.16 (August 22, 1999) Extending an interface built a wacky tree: had extra EXTENDS. Tree grammar didn't allow multiple superinterfaces. Tree grammar didn't allow empty var initializer: {} Version 1.17 (October 12, 1999) ESC lexer rule allowed 399 max not 377 max. java.tree.g didn't handle the expression of synchronized statements. Version 1.18 (August 12, 2001) Terence updated to Java 2 Version 1.3 by observing/combining work of Allan Jacobs and Steve Messick. Handles 1.3 src. Summary: o primary didn't include boolean.class kind of thing o constructor calls parsed explicitly now: see explicitConstructorInvocation o add strictfp modifier o missing objBlock after new expression in tree grammar o merged local class definition alternatives, moved after declaration o fixed problem with ClassName.super.field o reordered some alternatives to make things more efficient o long and double constants were not differentiated from int/float o whitespace rule was inefficient: matched only one char o add an examples directory with some nasty 1.3 cases o made Main.java use buffered IO and a Reader for Unicode support o supports UNICODE? Using Unicode charVocabulary makes code file big, but only in the bitsets at the end. I need to make ANTLR generate unicode bitsets more efficiently. Version 1.19 (April 25, 2002) Terence added in nice fixes by John Pybus concerning floating constants and problems with super() calls. John did a nice reorg of the primary/postfix expression stuff to read better and makes f.g.super() parse properly (it was METHOD_CALL not a SUPER_CTOR_CALL). Also: o "finally" clause was a root...made it a child of "try" o Added stuff for asserts too for Java 1.4, but *commented out* as it is not backward compatible. Version 1.20 (October 27, 2002) Terence ended up reorging John Pybus' stuff to remove some nondeterminisms and some syntactic predicates. Note that the grammar is stricter now; e.g., this(...) must be the first statement. Trinary ?: operator wasn't working as array name: (isBig ? bigDigits : digits)[i]; Checked parser/tree parser on source for Resin-2.0.5, jive-2.1.1, jdk 1.3.1, Lucene, antlr 2.7.2a4, and the 110k-line jGuru server source. Version 1.21 (October 17, 2003) Fixed lots of problems including: Ray Waldin: add typeDefinition to interfaceBlock in java.tree.g He found a problem/fix with floating point that start with 0 Ray also fixed problem that (int.class) was not recognized. Thorsten van Ellen noticed that \n are allowed incorrectly in strings. TJP fixed CHAR_LITERAL analogously. Version 1.21.2 (March, 2003) Changes by Matt Quail to support generics (as per JDK1.5/JSR14) Notes: o We only allow the "extends" keyword and not the "implements" keyword, since that's what JSR14 seems to imply. o Thanks to Monty Zukowski for his help on the antlr-interest mail list. o Thanks to Alan Eliasen for testing the grammar over his Fink source base Version 1.22 (July, 2004) Changes by Michael Studman to support Java 1.5 language extensions Notes: o Added support for annotations types o Finished off Matt Quail's generics enhancements to support bound type arguments o Added support for new for statement syntax o Added support for static import syntax o Added support for enum types o Tested against JDK 1.5 source base and source base of jdigraph project o Thanks to Matt Quail for doing the hard part by doing most of the generics work Version 1.22.1 (July 28, 2004) Bug/omission fixes for Java 1.5 language support o Fixed tree structure bug with classOrInterface - thanks to Pieter Vangorpto for spotting this o Fixed bug where incorrect handling of SR and BSR tokens would cause type parameters to be recognised as type arguments. o Enabled type parameters on constructors, annotations on enum constants and package definitions o Fixed problems when parsing if ((char.class.equals(c))) {} - solution by Matt Quail at Cenqua Version 1.22.2 (July 28, 2004) Slight refactoring of Java 1.5 language support o Refactored for/"foreach" productions so that original literal "for" literal is still used but the for sub-clauses vary by token type o Fixed bug where type parameter was not included in generic constructor's branch of AST Version 1.22.3 (August 26, 2004) Bug fixes as identified by Michael Stahl; clean up of tabs/spaces and other refactorings o Fixed typeParameters omission in identPrimary and newStatement o Replaced GT reconcilliation code with simple semantic predicate o Adapted enum/assert keyword checking support from Michael Stahl's java15 grammar o Refactored typeDefinition production and field productions to reduce duplication Version 1.22.4 (October 21, 2004) Small bux fixes o Added typeArguments to explicitConstructorInvocation, e.g. new MyParameterised() o Added typeArguments to postfixExpression productions for anonymous inner class super constructor invocation, e.g. new Outer().super() o Fixed bug in array declarations identified by Geoff Roy Version 1.22.4.g.1 o I have taken java.g for Java1.5 from Michael Studman (1.22.4) and have applied the groovy.diff from java.g (1.22) by John Rose back onto the new root (1.22.4) - Jeremy Rayner (Jan 2005) o for a map of the task see... http://groovy.javanicus.com/java-g.png Version 1.22.4.g.2 o mkempf, rkleeb, Dec 2007 o fixed various rules so that they call the correct Create Method to make sure that the line information are correct This grammar is in the PUBLIC DOMAIN

Field Summary
`static java.lang.String[]` | `_tokenNames`
`static java.util.BitSet` | `_tokenSet_0`
`static java.util.BitSet` | `_tokenSet_1`
`static java.util.BitSet` | `_tokenSet_10`
`static java.util.BitSet` | `_tokenSet_100`
`static java.util.BitSet` | `_tokenSet_101`
`static java.util.BitSet` | `_tokenSet_102`
`static java.util.BitSet` | `_tokenSet_103`
`static java.util.BitSet` | `_tokenSet_104`
`static java.util.BitSet` | `_tokenSet_105`
`static java.util.BitSet` | `_tokenSet_106`
`static java.util.BitSet` | `_tokenSet_11`
`static java.util.BitSet` | `_tokenSet_12`
`static java.util.BitSet` | `_tokenSet_13`
`static java.util.BitSet` | `_tokenSet_14`
`static java.util.BitSet` | `_tokenSet_15`
`static java.util.BitSet` | `_tokenSet_16`
`static java.util.BitSet` | `_tokenSet_17`
`static java.util.BitSet` | `_tokenSet_18`
`static java.util.BitSet` | `_tokenSet_19`
`static java.util.BitSet` | `_tokenSet_2`
`static java.util.BitSet` | `_tokenSet_20`
`static java.util.BitSet` | `_tokenSet_21`
`static java.util.BitSet` | `_tokenSet_22`
`static java.util.BitSet` | `_tokenSet_23`
`static java.util.BitSet` | `_tokenSet_24`
`static java.util.BitSet` | `_tokenSet_25`
`static java.util.BitSet` | `_tokenSet_26`
`static java.util.BitSet` | `_tokenSet_27`
`static java.util.BitSet` | `_tokenSet_28`
`static java.util.BitSet` | `_tokenSet_29`
`static java.util.BitSet` | `_tokenSet_3`
`static java.util.BitSet` | `_tokenSet_30`
`static java.util.BitSet` | `_tokenSet_31`
`static java.util.BitSet` | `_tokenSet_32`
`static java.util.BitSet` | `_tokenSet_33`
`static java.util.BitSet` | `_tokenSet_34`
`static java.util.BitSet` | `_tokenSet_35`
`static java.util.BitSet` | `_tokenSet_36`
`static java.util.BitSet` | `_tokenSet_37`
`static java.util.BitSet` | `_tokenSet_38`
`static java.util.BitSet` | `_tokenSet_39`
`static java.util.BitSet` | `_tokenSet_4`
`static java.util.BitSet` | `_tokenSet_40`
`static java.util.BitSet` | `_tokenSet_41`
`static java.util.BitSet` | `_tokenSet_42`
`static java.util.BitSet` | `_tokenSet_43`
`static java.util.BitSet` | `_tokenSet_44`
`static java.util.BitSet` | `_tokenSet_45`
`static java.util.BitSet` | `_tokenSet_46`
`static java.util.BitSet` | `_tokenSet_47`
`static java.util.BitSet` | `_tokenSet_48`
`static java.util.BitSet` | `_tokenSet_49`
`static java.util.BitSet` | `_tokenSet_5`
`static java.util.BitSet` | `_tokenSet_50`
`static java.util.BitSet` | `_tokenSet_51`
`static java.util.BitSet` | `_tokenSet_52`
`static java.util.BitSet` | `_tokenSet_53`
`static java.util.BitSet` | `_tokenSet_54`
`static java.util.BitSet` | `_tokenSet_55`
`static java.util.BitSet` | `_tokenSet_56`
`static java.util.BitSet` | `_tokenSet_57`
`static java.util.BitSet` | `_tokenSet_58`
`static java.util.BitSet` | `_tokenSet_59`
`static java.util.BitSet` | `_tokenSet_6`
`static java.util.BitSet` | `_tokenSet_60`
`static java.util.BitSet` | `_tokenSet_61`
`static java.util.BitSet` | `_tokenSet_62`
`static java.util.BitSet` | `_tokenSet_63`
`static java.util.BitSet` | `_tokenSet_64`
`static java.util.BitSet` | `_tokenSet_65`
`static java.util.BitSet` | `_tokenSet_66`
`static java.util.BitSet` | `_tokenSet_67`
`static java.util.BitSet` | `_tokenSet_68`
`static java.util.BitSet` | `_tokenSet_69`
`static java.util.BitSet` | `_tokenSet_7`
`static java.util.BitSet` | `_tokenSet_70`
`static java.util.BitSet` | `_tokenSet_71`
`static java.util.BitSet` | `_tokenSet_72`
`static java.util.BitSet` | `_tokenSet_73`
`static java.util.BitSet` | `_tokenSet_74`
`static java.util.BitSet` | `_tokenSet_75`
`static java.util.BitSet` | `_tokenSet_76`
`static java.util.BitSet` | `_tokenSet_77`
`static java.util.BitSet` | `_tokenSet_78`
`static java.util.BitSet` | `_tokenSet_79`
`static java.util.BitSet` | `_tokenSet_8`
`static java.util.BitSet` | `_tokenSet_80`
`static java.util.BitSet` | `_tokenSet_81`
`static java.util.BitSet` | `_tokenSet_82`
`static java.util.BitSet` | `_tokenSet_83`
`static java.util.BitSet` | `_tokenSet_84`
`static java.util.BitSet` | `_tokenSet_85`
`static java.util.BitSet` | `_tokenSet_86`
`static java.util.BitSet` | `_tokenSet_87`
`static java.util.BitSet` | `_tokenSet_88`
`static java.util.BitSet` | `_tokenSet_89`
`static java.util.BitSet` | `_tokenSet_9`
`static java.util.BitSet` | `_tokenSet_90`
`static java.util.BitSet` | `_tokenSet_91`
`static java.util.BitSet` | `_tokenSet_92`
`static java.util.BitSet` | `_tokenSet_93`
`static java.util.BitSet` | `_tokenSet_94`
`static java.util.BitSet` | `_tokenSet_95`
`static java.util.BitSet` | `_tokenSet_96`
`static java.util.BitSet` | `_tokenSet_97`
`static java.util.BitSet` | `_tokenSet_98`
`static java.util.BitSet` | `_tokenSet_99`
`static boolean` | `tracing`

Constructor Summary
`protected GroovyRecognizer(antlr.TokenBuffer tokenBuf, int k)`
`GroovyRecognizer(antlr.TokenBuffer tokenBuf)`
`protected GroovyRecognizer(antlr.TokenStream lexer, int k)`
`GroovyRecognizer(antlr.TokenStream lexer)`
`GroovyRecognizer(antlr.ParserSharedInputState state)`

Method Summary
`void` | `aCase()`
`void` | `addWarning(java.lang.String warning, java.lang.String solution)`
`void` | `additiveExpression(int lc_stmt)`
`void` | `andExpression(int lc_stmt)`
`void` | `annotation()`
`void` | `annotationArguments()`
`void` | `annotationBlock()`
`void` | `annotationDefinition(antlr.collections.AST modifiers)`
`void` | `annotationField()`
`void` | `annotationIdent()`
`void` | `annotationMemberArrayValueInitializer()`
`void` | `annotationMemberValueInitializer()`
`void` | `annotationMemberValuePair()`
`void` | `annotationMemberValuePairs()`
`void` | `annotationsInternal()`
`void` | `annotationsOpt()`
`void` | `appendedBlock(antlr.collections.AST callee)` An appended block follows any expression.
`void` | `argList()`
`byte` | `argument()` A single argument in (...) or [...].
`void` | `argumentLabel()` A label for an argument is of the form a:b, 'a':b, "a":b, (a):b, etc..
`void` | `argumentLabelStart()` For lookahead only.
`void` | `assignmentExpression(int lc_stmt)`
`void` | `assignmentLessExpression()` In Java, "if", "while", and "for" statements can take random, non-braced statements as their bodies.
`void` | `balancedBrackets()` Fast lookahead across balanced brackets of all sorts.
`void` | `balancedTokens()` lookahead predicate for usage of generics in methods as parameter for the method.
`void` | `blockBody(int prevToken)`
`void` | `branchStatement()` In Groovy, return, break, continue, throw, and assert can be used in a parenthesized expression context.
`protected void` | `buildTokenTypeASTClassMap()`
`void` | `builtInType()`
`void` | `builtInTypeArraySpec(boolean addImagNode)`
`void` | `builtInTypeSpec(boolean addImagNode)`
`void` | `caseSList()`
`void` | `casesGroup()`
`void` | `checkSuspiciousExpressionStatement(int prevToken)` If two statements are separated by newline (not SEMI), the second had better not look like the latter half of an expression.
`void` | `classBlock()`
`void` | `classDefinition(antlr.collections.AST modifiers)`
`void` | `classField()`
`void` | `classOrInterfaceType(boolean addImagNode)`
`void` | `classTypeSpec(boolean addImagNode)`
`Token` | `cloneToken(Token t)`
`void` | `closableBlock()` A sub-block of a block can be either open or closable.
`void` | `closableBlockConstructorExpression()` A list constructor is a argument list enclosed in square brackets, without labels.
`void` | `closableBlockParam()`
`void` | `closableBlockParamsOpt(boolean addImplicit)` Closure parameters are exactly like method parameters, except that they are not enclosed in parentheses, but rather are prepended to the front of a block, just after the brace.
`void` | `closableBlockParamsStart()`
`void` | `closureList()`
`void` | `commandArgument()`
`void` | `commandArguments(antlr.collections.AST head)`
`void` | `commandArgumentsGreedy(antlr.collections.AST head)`
`void` | `compatibleBodyStatement()`
`void` | `compilationUnit()`
`void` | `compoundStatement()` I've split out constructors separately; we could maybe integrate back into variableDefinitions later on if we maybe simplified 'def' to be a type declaration?
`void` | `conditionalExpression(int lc_stmt)`
`void` | `constant()`
`void` | `constantNumber()` Numeric constant.
`void` | `constructorBody()`
`void` | `constructorDefinition(antlr.collections.AST mods)`
`void` | `constructorStart()` Used to look ahead for a constructor
`void` | `controlExpressionList()`
`antlr.collections.AST` | `create(int type, java.lang.String txt, antlr.collections.AST first)` Create an AST node with the token type and text passed in, but with the same background information as another supplied Token (e.g.
`antlr.collections.AST` | `create(int type, java.lang.String txt, Token first, Token last)`
`antlr.collections.AST` | `create(int type, java.lang.String txt, antlr.collections.AST first, Token last)`
`antlr.collections.AST` | `create(int type, java.lang.String txt, antlr.collections.AST first, antlr.collections.AST last)` Clones the token
`void` | `declaration()`
`void` | `declarationStart()`
`void` | `declaratorBrackets(antlr.collections.AST typ)` After some type names, where zero or more empty bracket pairs are allowed.
`void` | `dynamicMemberName()`
`void` | `enumBlock()`
`void` | `enumConstant()`
`void` | `enumConstantBlock()`
`void` | `enumConstantField()`
`void` | `enumConstants()` Comma-separated list of one or more enum constant definitions.
`void` | `enumConstantsStart()` Guard for enumConstants.
`void` | `enumDefinition(antlr.collections.AST modifiers)`
`void` | `equalityExpression(int lc_stmt)`
`void` | `exclusiveOrExpression(int lc_stmt)`
`void` | `explicitConstructorInvocation()` Catch obvious constructor calls, but not the expr.super(...) calls
`void` | `expression(int lc_stmt)`
`void` | `expressionStatement(int prevToken)`
`void` | `expressionStatementNoCheck()`
`void` | `finallyClause()` A member name (x.y) or element name (x[y]) can serve as a command name, which may be followed by a list of arguments.
`void` | `forCond()`
`void` | `forInClause()`
`void` | `forInit()`
`void` | `forIter()`
`void` | `forStatement()`
`void` | `genericMethod()`
`void` | `genericMethodStart()`
`org.codehaus.groovy.antlr.parser.GroovyLexer` | `getLexer()`
`java.util.List` | `getWarningList()`
`void` | `handler()`
`void` | `identifier()`
`void` | `identifierStar()`
`void` | `implementsClause()`
`void` | `implicitParameters()` A block known to be a closure, but which omits its arguments, is given this placeholder.
`void` | `importStatement()`
`void` | `inclusiveOrExpression(int lc_stmt)`
`void` | `indexPropertyArgs(antlr.collections.AST indexee)` If a dot is followed by a parenthesized or quoted expression, the member is computed dynamically, and the member selection is done only at runtime.
`void` | `interfaceBlock()`
`void` | `interfaceDefinition(antlr.collections.AST modifiers)`
`void` | `interfaceExtends()`
`void` | `interfaceField()`
`void` | `keywordPropertyNames()`
`void` | `listOfVariables(antlr.collections.AST mods, antlr.collections.AST t, Token first)` Declaration of a variable.
`void` | `listOrMapConstructorExpression()`
`void` | `logicalAndExpression(int lc_stmt)`
`void` | `logicalOrExpression(int lc_stmt)`
`static GroovyRecognizer` | `make(org.codehaus.groovy.antlr.parser.GroovyLexer lexer)` This factory is the correct way to wire together a Groovy parser and lexer.
`static GroovyRecognizer` | `make(java.io.InputStream in)`
`static GroovyRecognizer` | `make(java.io.Reader in)`
`static GroovyRecognizer` | `make(antlr.InputBuffer in)`
`static GroovyRecognizer` | `make(antlr.LexerSharedInputState in)`
`void` | `matchGenericTypeBracketsFailed(java.lang.String problem, java.lang.String solution)`
`void` | `methodCallArgs(antlr.collections.AST callee)` An expression may be followed by one or both of (...) and {...}.
`void` | `modifier()`
`void` | `modifiers()` A list of one or more modifier, annotation, or "def".
`void` | `modifiersInternal()`
`void` | `modifiersOpt()` Used only as a lookahead predicate for nested type declarations.
`void` | `multicatch()`
`void` | `multicatch_types()`
`void` | `multipleAssignment(int lc_stmt)`
`void` | `multipleAssignmentDeclaration()`
`void` | `multipleAssignmentDeclarationStart()`
`void` | `multiplicativeExpression(int lc_stmt)`
`void` | `namePart()` This is the grammar for what can follow a dot: x.a, x.
`void` | `newArrayDeclarator()`
`void` | `newExpression()` object instantiation.
`void` | `nls()` Zero or more insignificant newlines, all gobbled up and thrown away.
`void` | `nlsWarn()` Zero or more insignificant newlines, all gobbled up and thrown away, but a warning message is left for the user, if there was a newline.
`void` | `openBlock()` An open block is not allowed to have closure arguments.
`void` | `openOrClosableBlock()` A labeled statement, consisting of a vanilla identifier followed by a colon.
`void` | `packageDefinition()` A statement is an element of a block.
`void` | `parameterDeclaration()` A formal parameter for a method or closure.
`void` | `parameterDeclarationList()` A list of zero or more formal parameters.
`void` | `parameterModifiersOpt()`
`void` | `parenthesizedExpression()`
`void` | `pathChain(int lc_stmt, antlr.collections.AST prefix)`
`void` | `pathElement(antlr.collections.AST prefix)`
`void` | `pathElementStart()`
`void` | `pathExpression(int lc_stmt)`
`void` | `postfixExpression(int lc_stmt)`
`void` | `powerExpression(int lc_stmt)`
`void` | `powerExpressionNotPlusMinus(int lc_stmt)`
`void` | `primaryExpression()`
`void` | `qualifiedTypeName()`
`void` | `regexExpression(int lc_stmt)`
`void` | `relationalExpression(int lc_stmt)`
`void` | `requireFailed(java.lang.String problem, java.lang.String solution)`
`void` | `sep()` A statement separator is either a semicolon or a significant newline.
`void` | `setFilename(java.lang.String f)`
`void` | `setSourceBuffer(SourceBuffer sourceBuffer)`
`void` | `shiftExpression(int lc_stmt)`
`void` | `singleDeclaration()`
`void` | `singleDeclarationNoInit()` A declaration with one declarator and no initialization, like a parameterDeclaration.
`void` | `singleVariable(antlr.collections.AST mods, antlr.collections.AST t)` Used in cases where a declaration cannot have commas, or ends with the "in" operator instead of '='.
`void` | `snippetUnit()` A Groovy script or simple expression.
`void` | `statement(int prevToken)`
`void` | `statementLabelPrefix()` An expression statement can be any general expression.
`boolean` | `strictContextExpression(boolean allowDeclaration)` Things that can show up as expressions, but only in strict contexts like inside parentheses, argument lists, and list constructors.
`void` | `stringConstructorExpression()`
`void` | `stringConstructorValuePart()`
`void` | `superClassClause()`
`void` | `suspiciousExpressionStatementStart()` Lookahead for suspicious statement warnings and errors.
`void` | `throwsClause()`
`void` | `traceIn(java.lang.String rname)`
`void` | `traceOut(java.lang.String rname)`
`void` | `tryBlock()`
`void` | `type()`
`void` | `typeArgument()`
`void` | `typeArgumentBounds()`
`void` | `typeArgumentSpec()`
`void` | `typeArguments()`
`void` | `typeArgumentsDiamond()`
`protected void` | `typeArgumentsOrParametersEnd()`
`void` | `typeDeclarationStart()`
`protected void` | `typeDefinitionInternal(antlr.collections.AST mods)`
`void` | `typeNamePairs(antlr.collections.AST mods, Token first)`
`void` | `typeParameter()`
`void` | `typeParameterBounds()`
`void` | `typeParameters()`
`void` | `typeSpec(boolean addImagNode)`
`void` | `unaryExpression(int lc_stmt)`
`void` | `unaryExpressionNotPlusMinus(int lc_stmt)`
`void` | `upperCaseIdent()` An IDENT token whose spelling is required to start with an uppercase letter.
`void` | `varInitializer()` An assignment operator '=' followed by an expression.
`void` | `variableDeclarator(antlr.collections.AST mods, antlr.collections.AST t, Token first)`
`void` | `variableDefinitions(antlr.collections.AST mods, antlr.collections.AST t)`
`void` | `variableName()`
`void` | `wildcardType()`

Methods inherited from class antlr.LLkParser
antlr.LLkParser#consume(), antlr.LLkParser#LA(int), antlr.LLkParser#traceIn(java.lang.String), antlr.LLkParser#traceOut(java.lang.String), antlr.LLkParser#LT(int), antlr.LLkParser#match(int), antlr.LLkParser#match(antlr.collections.impl.BitSet), antlr.LLkParser#mark(), antlr.LLkParser#rewind(int), antlr.LLkParser#reportError(antlr.RecognitionException), antlr.LLkParser#reportError(java.lang.String), antlr.LLkParser#getAST(), antlr.LLkParser#recover(antlr.RecognitionException, antlr.collections.impl.BitSet), antlr.LLkParser#matchNot(int), antlr.LLkParser#panic(), antlr.LLkParser#reportWarning(java.lang.String), antlr.LLkParser#setFilename(java.lang.String), antlr.LLkParser#traceIndent(), antlr.LLkParser#consumeUntil(int), antlr.LLkParser#consumeUntil(antlr.collections.impl.BitSet), antlr.LLkParser#getFilename(), antlr.LLkParser#getInputState(), antlr.LLkParser#setInputState(antlr.ParserSharedInputState), antlr.LLkParser#getTokenName(int), antlr.LLkParser#getASTFactory(), antlr.LLkParser#setASTNodeClass(java.lang.String), antlr.LLkParser#getTokenTypeToASTClassMap(), antlr.LLkParser#setTokenBuffer(antlr.TokenBuffer), antlr.LLkParser#addMessageListener(antlr.debug.MessageListener), antlr.LLkParser#addParserListener(antlr.debug.ParserListener), antlr.LLkParser#addParserMatchListener(antlr.debug.ParserMatchListener), antlr.LLkParser#isDebugMode(), antlr.LLkParser#addParserTokenListener(antlr.debug.ParserTokenListener), antlr.LLkParser#addSemanticPredicateListener(antlr.debug.SemanticPredicateListener), antlr.LLkParser#addSyntacticPredicateListener(antlr.debug.SyntacticPredicateListener), antlr.LLkParser#addTraceListener(antlr.debug.TraceListener), antlr.LLkParser#removeMessageListener(antlr.debug.MessageListener), antlr.LLkParser#removeParserListener(antlr.debug.ParserListener), antlr.LLkParser#removeParserMatchListener(antlr.debug.ParserMatchListener), antlr.LLkParser#removeParserTokenListener(antlr.debug.ParserTokenListener), antlr.LLkParser#removeSemanticPredicateListener(antlr.debug.SemanticPredicateListener), antlr.LLkParser#removeSyntacticPredicateListener(antlr.debug.SyntacticPredicateListener), antlr.LLkParser#removeTraceListener(antlr.debug.TraceListener), antlr.LLkParser#setASTFactory(antlr.ASTFactory), antlr.LLkParser#setASTNodeType(java.lang.String), antlr.LLkParser#setDebugMode(boolean), antlr.LLkParser#setIgnoreInvalidDebugCalls(boolean), antlr.LLkParser#getTokenNames(), antlr.LLkParser#wait(long), antlr.LLkParser#wait(long, int), antlr.LLkParser#wait(), antlr.LLkParser#equals(java.lang.Object), antlr.LLkParser#toString(), antlr.LLkParser#hashCode(), antlr.LLkParser#getClass(), antlr.LLkParser#notify(), antlr.LLkParser#notifyAll()

Methods inherited from class antlr.Parser
antlr.Parser#match(int), antlr.Parser#match(antlr.collections.impl.BitSet), antlr.Parser#mark(), antlr.Parser#rewind(int), antlr.Parser#consume(), antlr.Parser#reportError(antlr.RecognitionException), antlr.Parser#reportError(java.lang.String), antlr.Parser#getAST(), antlr.Parser#recover(antlr.RecognitionException, antlr.collections.impl.BitSet), antlr.Parser#LA(int), antlr.Parser#matchNot(int), antlr.Parser#panic(), antlr.Parser#reportWarning(java.lang.String), antlr.Parser#setFilename(java.lang.String), antlr.Parser#traceIndent(), antlr.Parser#traceIn(java.lang.String), antlr.Parser#traceOut(java.lang.String), antlr.Parser#consumeUntil(int), antlr.Parser#consumeUntil(antlr.collections.impl.BitSet), antlr.Parser#getFilename(), antlr.Parser#getInputState(), antlr.Parser#setInputState(antlr.ParserSharedInputState), antlr.Parser#getTokenName(int), antlr.Parser#getASTFactory(), antlr.Parser#setASTNodeClass(java.lang.String), antlr.Parser#getTokenTypeToASTClassMap(), antlr.Parser#setTokenBuffer(antlr.TokenBuffer), antlr.Parser#addMessageListener(antlr.debug.MessageListener), antlr.Parser#addParserListener(antlr.debug.ParserListener), antlr.Parser#addParserMatchListener(antlr.debug.ParserMatchListener), antlr.Parser#isDebugMode(), antlr.Parser#addParserTokenListener(antlr.debug.ParserTokenListener), antlr.Parser#addSemanticPredicateListener(antlr.debug.SemanticPredicateListener), antlr.Parser#addSyntacticPredicateListener(antlr.debug.SyntacticPredicateListener), antlr.Parser#addTraceListener(antlr.debug.TraceListener), antlr.Parser#removeMessageListener(antlr.debug.MessageListener), antlr.Parser#removeParserListener(antlr.debug.ParserListener), antlr.Parser#removeParserMatchListener(antlr.debug.ParserMatchListener), antlr.Parser#removeParserTokenListener(antlr.debug.ParserTokenListener), antlr.Parser#removeSemanticPredicateListener(antlr.debug.SemanticPredicateListener), antlr.Parser#removeSyntacticPredicateListener(antlr.debug.SyntacticPredicateListener), antlr.Parser#removeTraceListener(antlr.debug.TraceListener), antlr.Parser#setASTFactory(antlr.ASTFactory), antlr.Parser#setASTNodeType(java.lang.String), antlr.Parser#setDebugMode(boolean), antlr.Parser#setIgnoreInvalidDebugCalls(boolean), antlr.Parser#getTokenNames(), antlr.Parser#LT(int), antlr.Parser#wait(long), antlr.Parser#wait(long, int), antlr.Parser#wait(), antlr.Parser#equals(java.lang.Object), antlr.Parser#toString(), antlr.Parser#hashCode(), antlr.Parser#getClass(), antlr.Parser#notify(), antlr.Parser#notifyAll()

Field Detail

### _tokenNames

    public static final java.lang.String[] _tokenNames

### _tokenSet_0

    public static final java.util.BitSet _tokenSet_0

### _tokenSet_1

    public static final java.util.BitSet _tokenSet_1

### _tokenSet_10

    public static final java.util.BitSet _tokenSet_10

### _tokenSet_100

    public static final java.util.BitSet _tokenSet_100

### _tokenSet_101

    public static final java.util.BitSet _tokenSet_101

### _tokenSet_102

    public static final java.util.BitSet _tokenSet_102

### _tokenSet_103

    public static final java.util.BitSet _tokenSet_103

### _tokenSet_104

    public static final java.util.BitSet _tokenSet_104

### _tokenSet_105

    public static final java.util.BitSet _tokenSet_105

### _tokenSet_106

    public static final java.util.BitSet _tokenSet_106

### _tokenSet_11

    public static final java.util.BitSet _tokenSet_11

### _tokenSet_12

    public static final java.util.BitSet _tokenSet_12

### _tokenSet_13

    public static final java.util.BitSet _tokenSet_13

### _tokenSet_14

    public static final java.util.BitSet _tokenSet_14

### _tokenSet_15

    public static final java.util.BitSet _tokenSet_15

### _tokenSet_16

    public static final java.util.BitSet _tokenSet_16

### _tokenSet_17

    public static final java.util.BitSet _tokenSet_17

### _tokenSet_18

    public static final java.util.BitSet _tokenSet_18

### _tokenSet_19

    public static final java.util.BitSet _tokenSet_19

### _tokenSet_2

    public static final java.util.BitSet _tokenSet_2

### _tokenSet_20

    public static final java.util.BitSet _tokenSet_20

### _tokenSet_21

    public static final java.util.BitSet _tokenSet_21

### _tokenSet_22

    public static final java.util.BitSet _tokenSet_22

### _tokenSet_23

    public static final java.util.BitSet _tokenSet_23

### _tokenSet_24

    public static final java.util.BitSet _tokenSet_24

### _tokenSet_25

    public static final java.util.BitSet _tokenSet_25

### _tokenSet_26

    public static final java.util.BitSet _tokenSet_26

### _tokenSet_27

    public static final java.util.BitSet _tokenSet_27

### _tokenSet_28

    public static final java.util.BitSet _tokenSet_28

### _tokenSet_29

    public static final java.util.BitSet _tokenSet_29

### _tokenSet_3

    public static final java.util.BitSet _tokenSet_3

### _tokenSet_30

    public static final java.util.BitSet _tokenSet_30

### _tokenSet_31

    public static final java.util.BitSet _tokenSet_31

### _tokenSet_32

    public static final java.util.BitSet _tokenSet_32

### _tokenSet_33

    public static final java.util.BitSet _tokenSet_33

### _tokenSet_34

    public static final java.util.BitSet _tokenSet_34

### _tokenSet_35

    public static final java.util.BitSet _tokenSet_35

### _tokenSet_36

    public static final java.util.BitSet _tokenSet_36

### _tokenSet_37

    public static final java.util.BitSet _tokenSet_37

### _tokenSet_38

    public static final java.util.BitSet _tokenSet_38

### _tokenSet_39

    public static final java.util.BitSet _tokenSet_39

### _tokenSet_4

    public static final java.util.BitSet _tokenSet_4

### _tokenSet_40

    public static final java.util.BitSet _tokenSet_40

### _tokenSet_41

    public static final java.util.BitSet _tokenSet_41

### _tokenSet_42

    public static final java.util.BitSet _tokenSet_42

### _tokenSet_43

    public static final java.util.BitSet _tokenSet_43

### _tokenSet_44

    public static final java.util.BitSet _tokenSet_44

### _tokenSet_45

    public static final java.util.BitSet _tokenSet_45

### _tokenSet_46

    public static final java.util.BitSet _tokenSet_46

### _tokenSet_47

    public static final java.util.BitSet _tokenSet_47

### _tokenSet_48

    public static final java.util.BitSet _tokenSet_48

### _tokenSet_49

    public static final java.util.BitSet _tokenSet_49

### _tokenSet_5

    public static final java.util.BitSet _tokenSet_5

### _tokenSet_50

    public static final java.util.BitSet _tokenSet_50

### _tokenSet_51

    public static final java.util.BitSet _tokenSet_51

### _tokenSet_52

    public static final java.util.BitSet _tokenSet_52

### _tokenSet_53

    public static final java.util.BitSet _tokenSet_53

### _tokenSet_54

    public static final java.util.BitSet _tokenSet_54

### _tokenSet_55

    public static final java.util.BitSet _tokenSet_55

### _tokenSet_56

    public static final java.util.BitSet _tokenSet_56

### _tokenSet_57

    public static final java.util.BitSet _tokenSet_57

### _tokenSet_58

    public static final java.util.BitSet _tokenSet_58

### _tokenSet_59

    public static final java.util.BitSet _tokenSet_59

### _tokenSet_6

    public static final java.util.BitSet _tokenSet_6

### _tokenSet_60

    public static final java.util.BitSet _tokenSet_60

### _tokenSet_61

    public static final java.util.BitSet _tokenSet_61

### _tokenSet_62

    public static final java.util.BitSet _tokenSet_62

### _tokenSet_63

    public static final java.util.BitSet _tokenSet_63

### _tokenSet_64

    public static final java.util.BitSet _tokenSet_64

### _tokenSet_65

    public static final java.util.BitSet _tokenSet_65

### _tokenSet_66

    public static final java.util.BitSet _tokenSet_66

### _tokenSet_67

    public static final java.util.BitSet _tokenSet_67

### _tokenSet_68

    public static final java.util.BitSet _tokenSet_68

### _tokenSet_69

    public static final java.util.BitSet _tokenSet_69

### _tokenSet_7

    public static final java.util.BitSet _tokenSet_7

### _tokenSet_70

    public static final java.util.BitSet _tokenSet_70

### _tokenSet_71

    public static final java.util.BitSet _tokenSet_71

### _tokenSet_72

    public static final java.util.BitSet _tokenSet_72

### _tokenSet_73

    public static final java.util.BitSet _tokenSet_73

### _tokenSet_74

    public static final java.util.BitSet _tokenSet_74

### _tokenSet_75

    public static final java.util.BitSet _tokenSet_75

### _tokenSet_76

    public static final java.util.BitSet _tokenSet_76

### _tokenSet_77

    public static final java.util.BitSet _tokenSet_77

### _tokenSet_78

    public static final java.util.BitSet _tokenSet_78

### _tokenSet_79

    public static final java.util.BitSet _tokenSet_79

### _tokenSet_8

    public static final java.util.BitSet _tokenSet_8

### _tokenSet_80

    public static final java.util.BitSet _tokenSet_80

### _tokenSet_81

    public static final java.util.BitSet _tokenSet_81

### _tokenSet_82

    public static final java.util.BitSet _tokenSet_82

### _tokenSet_83

    public static final java.util.BitSet _tokenSet_83

### _tokenSet_84

    public static final java.util.BitSet _tokenSet_84

### _tokenSet_85

    public static final java.util.BitSet _tokenSet_85

### _tokenSet_86

    public static final java.util.BitSet _tokenSet_86

### _tokenSet_87

    public static final java.util.BitSet _tokenSet_87

### _tokenSet_88

    public static final java.util.BitSet _tokenSet_88

### _tokenSet_89

    public static final java.util.BitSet _tokenSet_89

### _tokenSet_9

    public static final java.util.BitSet _tokenSet_9

### _tokenSet_90

    public static final java.util.BitSet _tokenSet_90

### _tokenSet_91

    public static final java.util.BitSet _tokenSet_91

### _tokenSet_92

    public static final java.util.BitSet _tokenSet_92

### _tokenSet_93

    public static final java.util.BitSet _tokenSet_93

### _tokenSet_94

    public static final java.util.BitSet _tokenSet_94

### _tokenSet_95

    public static final java.util.BitSet _tokenSet_95

### _tokenSet_96

    public static final java.util.BitSet _tokenSet_96

### _tokenSet_97

    public static final java.util.BitSet _tokenSet_97

### _tokenSet_98

    public static final java.util.BitSet _tokenSet_98

### _tokenSet_99

    public static final java.util.BitSet _tokenSet_99

### tracing

    public static boolean tracing

Constructor Detail

### GroovyRecognizer

    protected GroovyRecognizer(antlr.TokenBuffer tokenBuf, int k)

### GroovyRecognizer

    public GroovyRecognizer(antlr.TokenBuffer tokenBuf)

### GroovyRecognizer

    protected GroovyRecognizer(antlr.TokenStream lexer, int k)

### GroovyRecognizer

    public GroovyRecognizer(antlr.TokenStream lexer)

### GroovyRecognizer

    public GroovyRecognizer(antlr.ParserSharedInputState state)

Method Detail

### aCase

    public final void aCase()

### addWarning

    public void addWarning(java.lang.String warning, java.lang.String solution)

### additiveExpression

    public final void additiveExpression(int lc_stmt)

### andExpression

    public final void andExpression(int lc_stmt)

### annotation

    public final void annotation()

### annotationArguments

    public final void annotationArguments()

### annotationBlock

    public final void annotationBlock()

### annotationDefinition

    public final void annotationDefinition(antlr.collections.AST modifiers)

### annotationField

    public final void annotationField()

### annotationIdent

    public final void annotationIdent()

### annotationMemberArrayValueInitializer

    public final void annotationMemberArrayValueInitializer()

### annotationMemberValueInitializer

    public final void annotationMemberValueInitializer()

### annotationMemberValuePair

    public final void annotationMemberValuePair()

### annotationMemberValuePairs

    public final void annotationMemberValuePairs()

### annotationsInternal

    public final void annotationsInternal()

### annotationsOpt

    public final void annotationsOpt()

### appendedBlock

    public final void appendedBlock(antlr.collections.AST callee)

  An appended block follows any expression. If the expression is not a method call, it is given an empty argument list.

### argList

    public final void argList()

### argument

    public final byte argument()

  A single argument in (...) or [...]. Corresponds to to a method or closure parameter. May be labeled. May be modified by the spread operator '*' ('*:' for keywords).

### argumentLabel

    public final void argumentLabel()

  A label for an argument is of the form a:b, 'a':b, "a":b, (a):b, etc.. The labels in (a:b), ('a':b), and ("a":b) are in all ways equivalent, except that the quotes allow more spellings. Equivalent dynamically computed labels are (('a'):b) and ("${'a'}":b) but not ((a):b) or "$a":b, since the latter cases evaluate (a) as a normal identifier. Bottom line: If you want a truly variable label, use parens and say ((a):b).

### argumentLabelStart

    public final void argumentLabelStart()

  For lookahead only. Fast approximate parse of an argumentLabel followed by a colon.

### assignmentExpression

    public final void assignmentExpression(int lc_stmt)

### assignmentLessExpression

    public final void assignmentLessExpression()

  In Java, "if", "while", and "for" statements can take random, non-braced statements as their bodies. Support this practice, even though it isn't very Groovy.

### balancedBrackets

    public final void balancedBrackets()

  Fast lookahead across balanced brackets of all sorts.

### balancedTokens

    public final void balancedTokens()

  lookahead predicate for usage of generics in methods as parameter for the method. Example: static T foo(){} must be first after the modifier. This rule allows more and does no exact match, but it is only a lookahead, not the real rule.

### blockBody

    public final void blockBody(int prevToken)

### branchStatement

    public final void branchStatement()

  In Groovy, return, break, continue, throw, and assert can be used in a parenthesized expression context. Example: println (x || (return)); println assert x, "won't print a false value!" If an optional expression is missing, its value is void (this coerces to null when a value is required).

### buildTokenTypeASTClassMap

    protected void buildTokenTypeASTClassMap()

### builtInType

    public final void builtInType()

### builtInTypeArraySpec

    public final void builtInTypeArraySpec(boolean addImagNode)

### builtInTypeSpec

    public final void builtInTypeSpec(boolean addImagNode)

### caseSList

    public final void caseSList()

### casesGroup

    public final void casesGroup()

### checkSuspiciousExpressionStatement

    public final void checkSuspiciousExpressionStatement(int prevToken)

  If two statements are separated by newline (not SEMI), the second had better not look like the latter half of an expression. If it does, issue a warning.

  Also, if the expression starts with a closure, it needs to have an explicit parameter list, in order to avoid the appearance of a compound statement. This is a hard error.

  These rules are different from Java's "dumb expression" restriction. Unlike Java, Groovy blocks can end with arbitrary (even dumb) expressions, as a consequence of optional 'return' and 'continue' tokens.

  To make the programmer's intention clear, a leading closure must have an explicit parameter list, and must not follow a previous statement separated only by newlines.

### classBlock

    public final void classBlock()

### classDefinition

    public final void classDefinition(antlr.collections.AST modifiers)

### classField

    public final void classField()

### classOrInterfaceType

    public final void classOrInterfaceType(boolean addImagNode)

### classTypeSpec

    public final void classTypeSpec(boolean addImagNode)

### cloneToken

    public Token cloneToken(Token t)

### closableBlock

    public final void closableBlock()

  A sub-block of a block can be either open or closable. It is closable if and only if there are explicit closure arguments. Compare this to a block which is appended to a method call, which is given closure arguments, even if they are not explicit in the code.

### closableBlockConstructorExpression

    public final void closableBlockConstructorExpression()

  A list constructor is a argument list enclosed in square brackets, without labels. Any argument can be decorated with a spread operator (*x), but not a label (a:x). Examples: [], [1], [1,2], [1,*l1,2], [*l1,*l2]. (The l1, l2 must be a sequence or null.)

  A map constructor is an argument list enclosed in square brackets, with labels everywhere, except on spread arguments, which stand for whole maps spliced in. A colon alone between the brackets also forces the expression to be an empty map constructor. Examples: [:], [a:1], [a:1,b:2], [a:1,*:m1,b:2], [*:m1,*:m2] (The m1, m2 must be a map or null.) Values associated with identical keys overwrite from left to right: [a:1,a:2] === [a:2]

  Some malformed constructor expressions are not detected in the parser, but in a post-pass. Bad examples: [1,b:2], [a:1,2], [:1]. (Note that method call arguments, by contrast, can be a mix of keyworded and non-keyworded arguments.)

### closableBlockParam

    public final void closableBlockParam()

### closableBlockParamsOpt

    public final void closableBlockParamsOpt(boolean addImplicit)

  Closure parameters are exactly like method parameters, except that they are not enclosed in parentheses, but rather are prepended to the front of a block, just after the brace. They are separated from the closure body by a CLOSABLE_BLOCK_OP token '->'.

### closableBlockParamsStart

    public final void closableBlockParamsStart()

### closureList

    public final void closureList()

### commandArgument

    public final void commandArgument()

### commandArguments

    public final void commandArguments(antlr.collections.AST head)

### commandArgumentsGreedy

    public final void commandArgumentsGreedy(antlr.collections.AST head)

### compatibleBodyStatement

    public final void compatibleBodyStatement()

### compilationUnit

    public final void compilationUnit()

### compoundStatement

    public final void compoundStatement()

  I've split out constructors separately; we could maybe integrate back into variableDefinitions later on if we maybe simplified 'def' to be a type declaration?

### conditionalExpression

    public final void conditionalExpression(int lc_stmt)

### constant

    public final void constant()

### constantNumber

    public final void constantNumber()

  Numeric constant.

### constructorBody

    public final void constructorBody()

### constructorDefinition

    public final void constructorDefinition(antlr.collections.AST mods)

### constructorStart

    public final void constructorStart()

  Used to look ahead for a constructor

### controlExpressionList

    public final void controlExpressionList()

### create

    public antlr.collections.AST create(int type, java.lang.String txt, antlr.collections.AST first)

  Create an AST node with the token type and text passed in, but with the same background information as another supplied Token (e.g. line numbers). To be used in place of antlr tree construction syntax, i.e. #[TOKEN,"text"] becomes create(TOKEN,"text",anotherToken) todo - change antlr.ASTFactory to do this instead...

### create

    public antlr.collections.AST create(int type, java.lang.String txt, Token first, Token last)

### create

    public antlr.collections.AST create(int type, java.lang.String txt, antlr.collections.AST first, Token last)

### create

    public antlr.collections.AST create(int type, java.lang.String txt, antlr.collections.AST first, antlr.collections.AST last)

  Clones the token

### declaration

    public final void declaration()

### declarationStart

    public final void declarationStart()

### declaratorBrackets

    public final void declaratorBrackets(antlr.collections.AST typ)

  After some type names, where zero or more empty bracket pairs are allowed. We use ARRAY_DECLARATOR to represent this. TODO: Is there some more Groovy way to view this in terms of the indexed property syntax?

### dynamicMemberName

    public final void dynamicMemberName()

### enumBlock

    public final void enumBlock()

### enumConstant

    public final void enumConstant()

### enumConstantBlock

    public final void enumConstantBlock()

### enumConstantField

    public final void enumConstantField()

### enumConstants

    public final void enumConstants()

  Comma-separated list of one or more enum constant definitions.

### enumConstantsStart

    public final void enumConstantsStart()

  Guard for enumConstants.

### enumDefinition

    public final void enumDefinition(antlr.collections.AST modifiers)

### equalityExpression

    public final void equalityExpression(int lc_stmt)

### exclusiveOrExpression

    public final void exclusiveOrExpression(int lc_stmt)

### explicitConstructorInvocation

    public final void explicitConstructorInvocation()

  Catch obvious constructor calls, but not the expr.super(...) calls

### expression

    public final void expression(int lc_stmt)

### expressionStatement

    public final void expressionStatement(int prevToken)

### expressionStatementNoCheck

    public final void expressionStatementNoCheck()

### finallyClause

    public final void finallyClause()

  A member name (x.y) or element name (x[y]) can serve as a command name, which may be followed by a list of arguments. Unlike parenthesized arguments, these must be plain expressions, without labels or spread operators.

### forCond

    public final void forCond()

### forInClause

    public final void forInClause()

### forInit

    public final void forInit()

### forIter

    public final void forIter()

### forStatement

    public final void forStatement()

### genericMethod

    public final void genericMethod()

### genericMethodStart

    public final void genericMethodStart()

### getLexer

    public org.codehaus.groovy.antlr.parser.GroovyLexer getLexer()

### getWarningList

    public java.util.List getWarningList()

### handler

    public final void handler()

### identifier

    public final void identifier()

### identifierStar

    public final void identifierStar()

### implementsClause

    public final void implementsClause()

### implicitParameters

    public final void implicitParameters()

  A block known to be a closure, but which omits its arguments, is given this placeholder. A subsequent pass is responsible for deciding if there is an implicit 'it' parameter, or if the parameter list should be empty.

### importStatement

    public final void importStatement()

### inclusiveOrExpression

    public final void inclusiveOrExpression(int lc_stmt)

### indexPropertyArgs

    public final void indexPropertyArgs(antlr.collections.AST indexee)

  If a dot is followed by a parenthesized or quoted expression, the member is computed dynamically, and the member selection is done only at runtime. This forces a statically unchecked member access.

### interfaceBlock

    public final void interfaceBlock()

### interfaceDefinition

    public final void interfaceDefinition(antlr.collections.AST modifiers)

### interfaceExtends

    public final void interfaceExtends()

### interfaceField

    public final void interfaceField()

### keywordPropertyNames

    public final void keywordPropertyNames()

### listOfVariables

    public final void listOfVariables(antlr.collections.AST mods, antlr.collections.AST t, Token first)

  Declaration of a variable. This can be a class/instance variable, or a local variable in a method It can also include possible initialization.

### listOrMapConstructorExpression

    public final void listOrMapConstructorExpression()

### logicalAndExpression

    public final void logicalAndExpression(int lc_stmt)

### logicalOrExpression

    public final void logicalOrExpression(int lc_stmt)

### make

    public static GroovyRecognizer make(org.codehaus.groovy.antlr.parser.GroovyLexer lexer)

  This factory is the correct way to wire together a Groovy parser and lexer.

### make

    public static GroovyRecognizer make(java.io.InputStream in)

### make

    public static GroovyRecognizer make(java.io.Reader in)

### make

    public static GroovyRecognizer make(antlr.InputBuffer in)

### make

    public static GroovyRecognizer make(antlr.LexerSharedInputState in)

### matchGenericTypeBracketsFailed

    public void matchGenericTypeBracketsFailed(java.lang.String problem, java.lang.String solution)

### methodCallArgs

    public final void methodCallArgs(antlr.collections.AST callee)

  An expression may be followed by one or both of (...) and {...}. Note: If either is (...) or {...} present, it is a method call. The {...} is appended to the argument list, and matches a formal of type Closure. If there is no method member, a property (or field) is used instead, and must itself be callable.

  If the methodCallArgs are absent, it is a property reference. If there is no property, it is treated as a field reference, but never a method reference.

  Arguments in the (...) can be labeled, and the appended block can be labeled also. If there is a mix of unlabeled and labeled arguments, all the labeled arguments must follow the unlabeled arguments, except that the closure (labeled or not) is always a separate final argument. Labeled arguments are collected up and passed as a single argument to a formal of type Map.

  Therefore, f(x,y, a:p, b:q) {s} is equivalent in all ways to f(x,y, [a:p,b:q], {s}). Spread arguments of sequence type count as unlabeled arguments, while spread arguments of map type count as labeled arguments. (This distinction must sometimes be checked dynamically.) A plain unlabeled argument is allowed to match a trailing Map or Closure argument: f(x, a:p) {s} === f(*[ x, [a:p], {s} ])

### modifier

    public final void modifier()

### modifiers

    public final void modifiers()

  A list of one or more modifier, annotation, or "def".

### modifiersInternal

    public final void modifiersInternal()

### modifiersOpt

    public final void modifiersOpt()

  Used only as a lookahead predicate for nested type declarations.

### multicatch

    public final void multicatch()

### multicatch_types

    public final void multicatch_types()

### multipleAssignment

    public final void multipleAssignment(int lc_stmt)

### multipleAssignmentDeclaration

    public final void multipleAssignmentDeclaration()

### multipleAssignmentDeclarationStart

    public final void multipleAssignmentDeclarationStart()

### multiplicativeExpression

    public final void multiplicativeExpression(int lc_stmt)

### namePart

    public final void namePart()

  This is the grammar for what can follow a dot: x.a, x.@a, x.&a, x.'a', etc. Note: `typeArguments` is handled by the caller of `namePart`.

### newArrayDeclarator

    public final void newArrayDeclarator()

### newExpression

    public final void newExpression()

  object instantiation. Trees are built as illustrated by the following input/tree pairs: new T() new | T -- ELIST | arg1 -- arg2 -- .. -- argn new int[] new | int -- ARRAY_DECLARATOR new int[] {1,2} new | int -- ARRAY_DECLARATOR -- ARRAY_INIT | EXPR -- EXPR | | 1 2 new int[3] new | int -- ARRAY_DECLARATOR | EXPR | 3 new int[1][2] new | int -- ARRAY_DECLARATOR | ARRAY_DECLARATOR -- EXPR | | EXPR 1 | 2

### nls

    public final void nls()

  Zero or more insignificant newlines, all gobbled up and thrown away.

### nlsWarn

    public final void nlsWarn()

  Zero or more insignificant newlines, all gobbled up and thrown away, but a warning message is left for the user, if there was a newline.

### openBlock

    public final void openBlock()

  An open block is not allowed to have closure arguments.

### openOrClosableBlock

    public final void openOrClosableBlock()

  A labeled statement, consisting of a vanilla identifier followed by a colon.

### packageDefinition

    public final void packageDefinition()

  A statement is an element of a block. Typical statements are declarations (which are scoped to the block) and expressions.

### parameterDeclaration

    public final void parameterDeclaration()

  A formal parameter for a method or closure.

### parameterDeclarationList

    public final void parameterDeclarationList()

  A list of zero or more formal parameters. If a parameter is variable length (e.g. String... myArg) it should be to the right of any other parameters of the same kind. General form: (req, ..., opt, ..., [rest], key, ..., [restKeys], [block] This must be sorted out after parsing, since the various declaration forms are impossible to tell apart without backtracking.

### parameterModifiersOpt

    public final void parameterModifiersOpt()

### parenthesizedExpression

    public final void parenthesizedExpression()

### pathChain

    public final void pathChain(int lc_stmt, antlr.collections.AST prefix)

### pathElement

    public final void pathElement(antlr.collections.AST prefix)

### pathElementStart

    public final void pathElementStart()

### pathExpression

    public final void pathExpression(int lc_stmt)

### postfixExpression

    public final void postfixExpression(int lc_stmt)

### powerExpression

    public final void powerExpression(int lc_stmt)

### powerExpressionNotPlusMinus

    public final void powerExpressionNotPlusMinus(int lc_stmt)

### primaryExpression

    public final void primaryExpression()

### qualifiedTypeName

    public final void qualifiedTypeName()

### regexExpression

    public final void regexExpression(int lc_stmt)

### relationalExpression

    public final void relationalExpression(int lc_stmt)

### requireFailed

    public void requireFailed(java.lang.String problem, java.lang.String solution)

### sep

    public final void sep()

  A statement separator is either a semicolon or a significant newline. Any number of additional (insignificant) newlines may accompany it.

### setFilename

    public void setFilename(java.lang.String f)

### setSourceBuffer

    public void setSourceBuffer(SourceBuffer sourceBuffer)

### shiftExpression

    public final void shiftExpression(int lc_stmt)

### singleDeclaration

    public final void singleDeclaration()

### singleDeclarationNoInit

    public final void singleDeclarationNoInit()

  A declaration with one declarator and no initialization, like a parameterDeclaration. Used to parse loops like `for (int x in y)` (up to the `in` keyword).

### singleVariable

    public final void singleVariable(antlr.collections.AST mods, antlr.collections.AST t)

  Used in cases where a declaration cannot have commas, or ends with the "in" operator instead of '='.

### snippetUnit

    public final void snippetUnit()

  A Groovy script or simple expression. Can be anything legal inside {...}.

### statement

    public final void statement(int prevToken)

### statementLabelPrefix

    public final void statementLabelPrefix()

  An expression statement can be any general expression.

  An expression statement can also be a command, which is a simple method call in which the outermost parentheses are omitted.

  Certain "suspicious" looking forms are flagged for the user to disambiguate.

### strictContextExpression

    public final boolean strictContextExpression(boolean allowDeclaration)

  Things that can show up as expressions, but only in strict contexts like inside parentheses, argument lists, and list constructors.

### stringConstructorExpression

    public final void stringConstructorExpression()

### stringConstructorValuePart

    public final void stringConstructorValuePart()

### superClassClause

    public final void superClassClause()

### suspiciousExpressionStatementStart

    public final void suspiciousExpressionStatementStart()

  Lookahead for suspicious statement warnings and errors.

### throwsClause

    public final void throwsClause()

### traceIn

    public void traceIn(java.lang.String rname)

### traceOut

    public void traceOut(java.lang.String rname)

### tryBlock

    public final void tryBlock()

### type

    public final void type()

### typeArgument

    public final void typeArgument()

### typeArgumentBounds

    public final void typeArgumentBounds()

### typeArgumentSpec

    public final void typeArgumentSpec()

### typeArguments

    public final void typeArguments()

### typeArgumentsDiamond

    public final void typeArgumentsDiamond()

### typeArgumentsOrParametersEnd

    protected final void typeArgumentsOrParametersEnd()

### typeDeclarationStart

    public final void typeDeclarationStart()

### typeDefinitionInternal

    protected final void typeDefinitionInternal(antlr.collections.AST mods)

### typeNamePairs

    public final void typeNamePairs(antlr.collections.AST mods, Token first)

### typeParameter

    public final void typeParameter()

### typeParameterBounds

    public final void typeParameterBounds()

### typeParameters

    public final void typeParameters()

### typeSpec

    public final void typeSpec(boolean addImagNode)

### unaryExpression

    public final void unaryExpression(int lc_stmt)

### unaryExpressionNotPlusMinus

    public final void unaryExpressionNotPlusMinus(int lc_stmt)

### upperCaseIdent

    public final void upperCaseIdent()

  An IDENT token whose spelling is required to start with an uppercase letter. In the case of a simple statement {UpperID name} the identifier is taken to be a type name, not a command name.

### varInitializer

    public final void varInitializer()

  An assignment operator '=' followed by an expression. (Never empty.)

### variableDeclarator

    public final void variableDeclarator(antlr.collections.AST mods, antlr.collections.AST t, Token first)

### variableDefinitions

    public final void variableDefinitions(antlr.collections.AST mods, antlr.collections.AST t)

### variableName

    public final void variableName()

### wildcardType

    public final void wildcardType()

Groovy Documentation